/*
 () 
e-mail: liloi@mail.ru
08.12.2005
*/

/*
mod_v_2d -      
mod_v_3d -      
d_pr -       
is_pr_paral -    
is_pr_perp -    
ugol_pr -      
ugol_plos -      
is_plos_paral -    
is_plos_perp -    
ppo_x -   . .    ( X)
ppo_y -   . .    ( Y)
c_pis -   ( )
paral_s_1 -   
paral_s_2 -   
trap_s -   
tr_s_1 -   
tr_s_2 -   
tr_s_3 -   
krug_s -   
krug_l -   
seg_s -   
kil_s -   
kon_v -   
kon_sbp -     
zkon_v -    
zkon_sbp -      
cil_v -   
cil_sbp -     
kul_v -   
kul_sp -   
*/

#include <math.h>

float mod_v_2d(float a, float b)
{
    float m = sqrt(a*a+b*b);
    return m;
}

float mod_v_3d(float a, float b, float c)
{
    float m = sqrt(a*a+b*b+c*c);
    return m;    
}

float d_pr(float a, float b, float c, float x, float y)
{
    float d = (a*x+b*y+c)/(sqrt(a*a+b*b));
    if(d<0) d = (-1)*d;
    return d;
}

bool is_pr_paral(float a1, float b1, float a2, float b2)
{
    if((a1/a2)==(b1/b2)) return true; else return false;
}

bool is_pr_perp(float a1, float b1, float a2, float b2)
{
    float q = a1*a2+b1*b2;
    if(q==0) return true; else return false;
}

float ugol_pr(float a1, float b1, float a2, float b2)
{
    float q = ((a1*a2)+(b1*b2))/(sqrt(a1*a1+b1*b1)*sqrt(a2*a2+b2*b2));
    return cos(q);
}

float ugol_plos(float a1, float b1, float c1, float a2, float b2, float c2)
{
    float q = (a1*a2+b1*b2+c1*c2)/(sqrt(a1*a1+b1*b1+c1*c1)*sqrt(a2*a2+b2*b2+c2*c2));
    return cos(q);
}

bool is_plos_paral(float a1, float b1, float c1, float a2, float b2, float c2)
{
    float q = a1*a2+b1*b2+c1*c2;
    if(q==0) return true; else return false;
}

bool is_plos_perp(float a1, float b1, float c1, float a2, float b2, float c2)
{
    if((a1/a2)==(b1/b2)==(c1/c2)) return true; else return false;
}

float ppo_x(float x, float y, float eps)
{
    float q = x*cos(eps)+y*sin(eps);
    return q;
}

float ppo_y(float x, float y, float eps)
{
    float q = y*cos(eps)-x*sin(eps);
    return q;
}

float c_pif(float a, float b)
{
    float q = sqrt(a*a+b*b);
    return q;
}

float paral_s_1(float a, float h)
{
    float s = a*h;
    return s;
}

float paral_s_2(float a, float b, float eps)
{
    float s = a*b*sin(eps);
    return s;
}

float trap_s(float a, float b, float h)
{
    float s = h*((a+b)/2);
    return s;
}

float tr_s_1(float a, float h)
{
    float s = (a*h)/2;
    return s;
}

float tr_s_2(float a, float b, float eps)
{
    float s = (a*b*sin(eps))/2;
    return s;
}

float tr_s_3(float a, float b, float c)
{
    float p = (a+b+c)/2;
    float s = sqrt(p*(p-a)*(p-b)*(p-c));
    return s;
}

float krug_s(float r)
{
    float s = r*r*M_PI;
    return s;
}

float krug_l(float r)
{
    float l = M_PI*r*2;
    return l;
}

float seg_s(float r, float eps)
{
    float s = (eps-sin(eps))*((r*r)/2);
    return s;
}

float kil_s(float R, float r)
{
    float s = M_PI*(R*R-r*r);
    return s;
}

float kon_v(float s, float h)
{
    float v = (s*h)/3;
    return v;
}

float kon_sbp(float r, float h)
{
    float sbp = M_PI*r*sqrt(r*r+h*h);
    return sbp;    
}

float zkon_v(float R, float r, float h)
{
    float v = (M_PI*(r*r+r*R+R*R)*h)/3;
    return v;
}

float zkon_sbp(float R, float r, float a)
{
    float sbp = M_PI*a*(R+r);
    return sbp;
}

float cil_v(float r, float h)
{
    float v = M_PI*r*r*h;
    return v;
}

float cil_sbp(float r, float h)
{
    float sbp = M_PI*r*h*2;
    return sbp;
}

float kul_v(float r)
{
    float v = (4*M_PI*r*r*r)/3;
    return v;
}

float kul_sp(float r)
{
    float sp = M_PI*r*r*4;
    return sp;
}
